#ifndef LIST_H
#define LIST_H

#include <stdlib.h>


typedef struct ListElmt_ {

void               *data;
struct ListElmt_   *next;

} ListElmt;


typedef struct List_ {

int                size;

//int                (*match)(const void *key1, const void *key2);
void               (*destroy)(void *data);

ListElmt           *head;
ListElmt           *tail;

} List;


void list_swap(List *list, ListElmt *e1, ListElmt *e2);

void list_init(List *list, void (*destroy)(void *data));

void list_destroy(List *list);

int list_ins_next(List *list, ListElmt *element, const void *data);

int list_rem_next(List *list, ListElmt *element, void **data);

int list_rem(List *list, ListElmt *element);

ListElmt *list_prev(List *, ListElmt *);

ListElmt *list_find_data_next(ListElmt *, void *);

#define list_find_data(list,data) list_find_data_next(list_head(list),data);

List *list_sort(List *,int (* cmp_func)(void *, void *));

ListElmt *list_match_next(ListElmt *, void *, int (* cmp_func)(void *p1, void *p2));

#define list_match(list,data,func) list_match_next(list_head(list),data,func);

#define list_size(list) ((list)->size)

#define list_head(list) ((list)->head)

#define list_tail(list) ((list)->tail)

#define list_is_head(list, element) ((element) == (list)->head ? 1 : 0)

#define list_is_empty(list) (list_head(list,element) == NULL ? 1 : 0)

#define list_is_tail(element) ((element)->next == NULL ? 1 : 0)

#define list_next(element) ((element)==NULL ? NULL : (element)->next)

#define list_data(element) ((element)->data)

int list_rem(List *, ListElmt *);

#define list_append(list, data) list_ins_next(list, (list)->tail, data)

#endif
