#include<stdio.h>
#include<limits.h>
#include<string.h>
#include "list.h"

#define N 50

#define STATUS_TRANSFERRING "transferring"
#define STATUS_WAITING "waiting"
#define STATUS_PAUSED "paused"

#define TFTYPE_DOWNLOAD "download"
#define TFTYPE_UPLOAD "upload"

/* Definition of queue structure */
typedef struct queuestruct
{
	int priority;
	char file_name[PATH_MAX];
	int tf_size;
	int file_size;
	char local_path[PATH_MAX];
	char serv_path[PATH_MAX];
	char statut[20];
	int thread_num;
	char error_msg[255];
	char tf_type[20];
		
}queue_struct;

/* Function which copy 's' string to 'dest' */
/* for each line, this function read each string separates by '|' */
char *scan(char *s, char *dest)
{
	int i=0;
	while((s[i] != '|')&&(s[i]!='\n'))	//find pipes
	{
		i++;
	}

	strncpy(dest,s,i);	//copy string of length 'i' from 's' to 'dest'
	dest[i]='\0';		//replace pipes by '\0'
	return s+i+1;
}

/* Function which reads each element of queue */
void reading(char *file_name,List *queue)
{
	queue_struct *qelmt;
	char string[1000];
	char line[1000];
	char *ptr;
	FILE *file;
	file=fopen(file_name,"r");

	while(!feof(file))
	{
		line[0]='\0';
		fgets(&line[0], 999, file);
		if(feof(file))	break;

		//printf("%i\n",strlen(line));

		ptr=&line[0];
		qelmt=malloc(sizeof(queue_struct));

		/* pick up each element and put them in queue */
		ptr=scan(ptr, &string[0]);
		qelmt->priority=atoi(string);

		ptr=scan(ptr, qelmt->file_name);

		ptr=scan(ptr, &string[0]);
		qelmt->tf_size=atoi(string);

		ptr=scan(ptr, &string[0]);
		qelmt->file_size=atoi(string);

		ptr=scan(ptr, qelmt->local_path);

		ptr=scan(ptr, qelmt->serv_path);

		ptr=scan(ptr, qelmt->statut);

		ptr=scan(ptr, &string[0]);
		qelmt->thread_num=atoi(string);

		ptr=scan(ptr, qelmt->error_msg);

		ptr=scan(ptr, qelmt->tf_type);

		/* Append each element at the end of queue */
		list_append(queue, qelmt);
		//printf("size: %i\n",queue->size);
	}
	fclose(file);
}

/* Function which writes each element of queue in a file */
void writing(char *file_name, List *queue)
{

	queue_struct *qelmt;
	ListElmt *elmt=malloc(sizeof(ListElmt));


	FILE *file;
	file=fopen(file_name,"w");

	qelmt=malloc(sizeof(queue_struct));
	//printf("size: %i\n",queue->size);
	/* Get the first element of the queue */
	elmt=queue->head;
	while(elmt!=NULL)
	{
		/* Print in file all element's data */
		qelmt=elmt->data;
		fprintf(file, "%i|%s|%i|%i|%s|%s|%s|%i|%s|%s\n",qelmt->priority, qelmt->file_name, qelmt->tf_size, qelmt->file_size, qelmt->local_path, qelmt->serv_path, qelmt->statut, qelmt->thread_num, qelmt->error_msg, qelmt->tf_type);
		elmt=list_next(elmt);
	}
	fclose(file);
}

/* Main function */
int main()
{
	List queue;
	list_init(&queue,free);
	printf("OK !!!! \n");
	reading("queue.txt",&queue);
	writing("queue2.txt", &queue);

	return 0;

}
